from ..vector.species import set_params_by_species


params = {
    "Acquisition_Blocking_Immunity_Decay_Rate": 1,
    "Acquisition_Blocking_Immunity_Duration_Before_Decay": 700,
    "Age_Dependent_Biting_Risk_Type": "OFF",
    "Air_Temperature_Variance": 0,
    "x_Base_Population": 0.1,
    "Burnin_Cache_Mode": "none",
    "Burnin_Cache_Period": 0,
    "Burnin_Name": "",
    "Config_Name": "",
    "Death_Rate_Dependence": "NOT_INITIALIZED",
    "Default_Geography_Initial_Node_Population": 1000,
    "Default_Geography_Torus_Size": 5,
    "Drought_Egg_Hatch_Delay": 0.33,
    "Egg_Arrhenius1": 61599956.864,
    "Egg_Arrhenius2": 5754.033,
    "Egg_Hatch_Delay_Distribution": "EXPONENTIAL_DISTRIBUTION",
    "Egg_Hatch_Density_Dependence": "DENSITY_DEPENDENCE",
    "Enable_Absolute_Time": "NO",
    "Enable_Birth": 0,
    "Enable_Climate_Stochasticity": 0,
    "Enable_Delayed_Hatching_When_Habitat_Dries_Up": 1,
    "Enable_Demographics_Birth": 0,
    "Enable_Demographics_Other": 0,
    "Enable_Demographics_Reporting": 1,
    "Enable_Drought_Egg_Hatch_Delay": 0,
    "Enable_Egg_Mortality": 1,
    "Enable_Rainfall_Stochasticity": 0,
    "Enable_Superinfection":0,
    "Enable_Temperature_Dependent_Egg_Hatching": 1,
    "Temperature_Dependent_Feeding_Cycle": "ARRHENIUS_DEPENDENCE",
    "Post_Infection_Acquisition_Multiplier": 0,
    "Infectiousness_Asymptomatic_Naive_1": 0.1740627,
    "Infectiousness_Asymptomatic_Naive_2": 5.6850991,
    "Infectiousness_Asymptomatic_Naive_3": 1.3523544,
    "Infectiousness_Asymptomatic_Reinfected_1": 0.5475231,
    "Infectiousness_Asymptomatic_Reinfected_2": 4.4786918,
    "Infectiousness_Asymptomatic_Reinfected_3": 1.8073960,
    "Infectiousness_Symptomatic_Naive_1": 0.2183788,
    "Infectiousness_Symptomatic_Naive_2": 5.3742552,
    "Infectiousness_Symptomatic_Naive_3": 1.0735513,
    "Infectiousness_Symptomatic_Reinfected_1": 0.6311345,
    "Infectiousness_Symptomatic_Reinfected_2": 4.3654233,
    "Infectiousness_Symptomatic_Reinfected_3": 1.3090332,
    "Innate_Immune_Variation_Type": "NONE",
    "Job_Node_Groups": "Chassis08",
    "Job_Priority": "BELOWNORMAL",
    "Local_Simulation": 0,
    "Maternal_Antibodies_Type": "OFF",
    "Maternal_Infection_Transmission_Probability": 0,
    "Max_Individual_Infections": 2,
    "Mean_Egg_Hatch_Delay": 3,
    "Minimum_Adult_Age_Years": 14,
    "Number_Basestrains": 4,
    "Pool_Transmission_Mode": "ENVIRONMENTAL_AND_CONTACT_TRANSMISSION",
    "Python_Script_Path": "NO",
    "RBC_Destruction_Multiplier": 1,
    "Reporting_Onset_Delay_Mean": 2,
    "Reporting_Period_Distribution": "LOG_NORMAL_DISTRIBUTION",
    "Reporting_Period_Log_Normal_Mu": 2,
    "Reporting_Period_Log_Normal_Sigma": 0.27,
    "Run_Number": 26,
    "Simulation_Duration": 500,
    "Simulation_Type": "DENGUE_SIM",
    "Strain1_Background_Exposure":0.01,
    "Strain2_Background_Exposure":0.01,
    "Strain3_Background_Exposure":0.01,
    "Strain4_Background_Exposure":0.01,
    "Strain1_Infectiousness_Multiplier": 1.0,
    "Strain2_Infectiousness_Multiplier": 1.0,
    "Strain3_Infectiousness_Multiplier": 1.0,
    "Strain4_Infectiousness_Multiplier": 1.0,
    "Symptomatic_Probability_Naive": 0.69,
    "Symptomatic_Probability_Reinfected": 0.25,
    "Symptomatic_Probability_Postsecondary": 0.07,
    "Symptomatic_Reporting_Rate": 0.08,
    ".Vector_Sampling_Type": "VECTOR_COMPARTMENTS_NUMBER",
    "Vector_Sampling_Type": "TRACK_ALL_VECTORS",
    "Vector_Species_Params": [],
    "x_Temporary_Larval_Habitat": 0.01,
    ".logLevel_StrainIdentity": "DEBUG",
    ".logLevel_InfectionDengue": "DEBUG",
    ".logLevel_TransmissionGroupsBase": "DEBUG",
    ".logLevel_StrainAwareTransmissionGroups": "DEBUG",
    ".logLevel_SusceptibilityDengue": "DEBUG",
    ".logLevel_VectorTransmissionGroups": "DEBUG"
}

set_params_by_species(params, ["aegypti"], "DENGUE_SIM")
